import * as GameTest from "mojang-gametest";
import { BlockLocation, MinecraftItemTypes, ItemStack, world } from "mojang-minecraft";

GameTest.register("DebugTests", "always_fail", (test) => {
  // Do nothing, let the test time out
})
  .maxTicks(50)
  .tag(GameTest.Tags.suiteDebug);

GameTest.register("DebugTests", "always_succeed", (test) => {
  test.runAfterDelay(40, () => {
    test.succeed();
  });
})
  .maxTicks(50)
  .tag(GameTest.Tags.suiteDebug);

GameTest.register("DebugTests", "stack_overflow", (test) => {
  let player = test.spawnSimulatedPlayer(new BlockLocation(1, 2, 1), "stack_overflow");
  let apple = new ItemStack(MinecraftItemTypes.apple);
  let eventCallback = world.events.beforeItemUse.subscribe((eventData) => {
    player.useItem(apple);
  });
  player.useItem(apple);
  world.events.beforeItemUse.unsubscribe(eventCallback);
  test.succeed();
})
  .tag(GameTest.Tags.suiteDebug)
  .structureName("ComponentTests:platform");
